#!/bin/sh
# SCCSID(@(#)quickdownload.sh	1.18) Modified 17:47:24 8/23/00
##############################################################################
#         quickdownload.sh                                                   #
#         RPM selection and Installation Script for NeTraverse Win4Lin       #
#         Create a sparse installation for efficient downloading             #
#                                                                            #
##############################################################################
#
#         NeTraverse, Inc. 
#
# NOTE:: this script may need to be customized to reflect actual
# download parameters.  see HOST, ROOT, FTPUSER, TARGETDIR
#
HOST="ftp.netraverse.com"
FTPUSER="anonymous"
FTPPASSWD=`whoami`@`uname -n`
TARGET_DIR="Win4Lin2.0-eval"
ROOT="/pub/win4lin/Win4Lin2.0-eval"
#
# Other Globals
KERNELPATH="LINUX"
RPM=
RH7="no"
TOOLS="$KERNELPATH/tools/insmod.gz $KERNELPATH/tools/rmmod.gz"
TEXT="INSTALL.txt INSTALL.html README Win4Lin/win4lin_eula.txt Win4Lin/relnote.html"
INSTALLSCRIPTS="$KERNELPATH/install-kernel.sh Win4Lin/install-win4lin.sh"
YES_ANS=0
NO_ANS=1

# Ask a question, and return $YES_ANS or $NO_ANS
Ask_y_n()
{
        while true
        do
                echo -e "$1 (y/n)?\c"
                read ANS
                case $ANS in
                y*|Y*)
                        return $YES_ANS
                        ;;
                n*|N*)
                        return $NO_ANS
                        ;;
                *)
                        echo "Please answer y for yes, n for no"
                        ;;
                esac
        done
}                       

Get_Kernel_Version()
{

VERSION=`cat /proc/version`
CALDERA22="Linux version 2.2.5 (root@knob.calderasystems.com)"
CALDERA23="Linux version 2.2.10 (root@tuvok.calderasystems.com)"
CALDERA24SMP="Linux version 2.2.14 (root@bm.calderalabs.com)"
CALDERA24SMPCD="Linux version 2.2.14 (root@athlon.lst.de)"
CALDERA24SMPSF="Linux version 2.2.14 (root@cinema.lst.de)"
MANDRAKE61="Linux version 2.2.13-7mdk (root@kenobi.mandrakesoft.com)"
MANDRAKESMP61="Linux version 2.2.13-7mdksmp (root@kenobi.mandrakesoft.com)"
MANDRAKE70="Linux version 2.2.14-15mdk (root@kenobi.mandrakesoft.com)"
MANDRAKE71="Linux version 2.2.15-4mdk (chmou@kenobi.mandrakesoft.com)"
MANDRAKESMP71="Linux version 2.2.15-4mdksmp (chmou@kenobi.mandrakesoft.com)"
REDHAT15="Linux version 2.2.5-15 (root@porky.devel.redhat.com)"
REDHAT61="Linux version 2.2.12-20 (root@porky.devel.redhat.com)"
REDHAT62="Linux version 2.2.14-5.0 (root@porky.devel.redhat.com)"
REDHAT62SMP="Linux version 2.2.14-5.0smp (root@porky.devel.redhat.com)"
REDHAT62_2216="Linux version 2.2.16-3 (root@porky.devel.redhat.com)"
REDHAT62SMP_2216="Linux version 2.2.16-3smp (root@porky.devel.redhat.com)"
REDHAT70_2216="Linux version 2.2.16-22 (root@porky.devel.redhat.com)"
REDHAT70SMP_2216="Linux version 2.2.16-22smp (root@porky.devel.redhat.com)"
SUSE61="Linux version 2.2.7 (root@Mandelbrot.suse.de)"
SUSE62="Linux version 2.2.10 (root@Mandelbrot.suse.de)"
SUSE63="Linux version 2.2.13 (root@euler)"
SUSE64="Linux version 2.2.14 (root@Pentium.suse.de)"
SUSE64SMP="Linux version 2.2.14-SMP (root@SMP_X86.suse.de)"


    if [ `grep -q "$CALDERA22" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Caldera2.2-01.i386.rpm

    elif [ `grep -q "$CALDERA23" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Caldera2.3-01.i386.rpm

    elif [ `grep -q "$CALDERA24SMP" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Caldera2.4smp-02.i386.rpm

    elif [ `grep -q "$CALDERA24SMPCD" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Caldera2.4smp-02.i386.rpm

    elif [ `grep -q "$CALDERA24SMPSF" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Caldera2.4smp-02.i386.rpm

    elif [ `grep -q "$MANDRAKE61" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Mandrake6.1-7.i686.rpm

    elif [ `grep -q "$MANDRAKESMP61" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Mandrake6.1-7.i686.rpm

    elif [ `grep -q "$MANDRAKE70" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Mandrake7.0-15.i686.rpm

    elif [ `grep -q "$MANDRAKE71" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Mandrake7.1-9.i586.rpm

    elif [ `grep -q "$MANDRAKESMP71" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-Mandrake7.1-9.i586.rpm

    elif [ `grep -q "$REDHAT15" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-RedHat6.0-15.i386.rpm

    elif [ `grep -q "$REDHAT61" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-RedHat6.1-20.i386.rpm

    elif [ `grep -q "$REDHAT62" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-RedHat6.2-1.i386.rpm

    elif [ `grep -q "$REDHAT62SMP" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-RedHat6.2smp-2.i386.rpm

    elif [ `grep -q "$REDHAT62_2216" /proc/version ; echo $?` -eq 0 ]; 
    then
    RPM=RPMS/Kernel-Win4Lin2-RedHat6.2_2.2.16.3-4.i386.rpm

    elif [ `grep -q "$REDHAT62SMP_2216" /proc/version ; echo $?` -eq 0 ]; 
    then
    RPM=RPMS/Kernel-Win4Lin2-RedHat6.2smp_2.2.16.3-4.i386.rpm

    elif [ `grep -q "$REDHAT70_2216" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin2-RedHat7.0_2.2.16.22-1.i386.rpm
    RH7="yes"

    elif [ `grep -q "$REDHAT70SMP_2216" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin2-RedHat7.0smp_2.2.16.22-1.i386.rpm
    RH7="yes"

    elif [ `grep -q "$SUSE61" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-SuSE6.1-01.i386.rpm

    elif [ `grep -q "$SUSE62" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-SuSE6.2-01.i386.rpm

    elif [ `grep -q "$SUSE63" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-SuSE6.3-01.i386.rpm

    elif [ `grep -q "$SUSE64" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-SuSE6.4_2.2.14-02.i386.rpm

    elif [ `grep -q "$SUSE64SMP" /proc/version ; echo $?` -eq 0 ];
    then
    RPM=RPMS/Kernel-Win4Lin1-SuSE6.4smp_2.2.14-02.i386.rpm

    elif [ `grep -q "mki_install_hook" /proc/ksyms ; echo $?` -eq 0 ];
    then
    echo "Congratulations, you already appear to be running a Win4Lin Enhanced Kernel."

    else
        RPM="PATCH/*"
        echo ""
        echo "You do not appear to be running a standard supported kernel."
        echo "You will need to manually PATCH your kernel."
        echo "Please see LINUX/PATCH/README"
        echo "and the Release Notes, for more information, on how to"
        echo "build and install a Win4Lin enhanced kernel."
        echo ""
    fi

}

Check_ed()
{
        if [ ! -x /bin/ed -a ! -x /usr/bin/ed ]
        then
            TOOLS="$TOOLS $KERNELPATH/tools/ed.gz"
        fi
}     

Download_Files()
{
    echo "Connecting to $HOST as user $FTPUSER ..."
    ftp -v -i -n $HOST << XXX
user $FTPUSER $FTPPASSWD
cd $ROOT
bin
mget $RPM $TEXT
mget $INSTALLSCRIPTS 
mget $TOOLS
mget $WIN4LIN
bye
XXX
    return 0
}

# MAIN
# Figure out what kernel we need to download, along with other ancilary
# programs and the win4lin rpm
# Download the files and start the installation

if [ `id -u` -ne 0 ] ; then
	echo ""
	echo "This script must be run as root - please su - and try again."
	echo ""
	exit 1
fi

Get_Kernel_Version

# Added to warn about Red Hat Linx 7.0 and broken glibc
if [ $RH7 = "yes" ]; then
	if [ `rpm -q glibc | grep -q "\<2\.1\.92\>"; echo $?` -eq 0 ]; then
		echo ""
		echo "You seem to be running Red Hat Linux 7.0 without the required Errata fixes."
		echo "Please follow the instructions at:"
		echo "http://www.netraverse.com/products/win4lin/docs/Win4Lin-2.0-RH7Update.php"
		echo ""
		exit 1
	fi
fi

Check_ed
if [ ! "$RPM" = "" ]
then
		RPM=$KERNELPATH/$RPM
fi
WIN4LIN="Win4Lin/RPMS/i386/Win4Lin*.rpm"
# make the directory hierarchy
mkdir -p $TARGET_DIR/Win4Lin/RPMS/i386
mkdir -p $TARGET_DIR/LINUX/RPMS
mkdir -p $TARGET_DIR/LINUX/PATCH
mkdir -p $TARGET_DIR/LINUX/tools
cd $TARGET_DIR
Download_Files
cd LINUX/tools
gunzip *.gz
chmod +x *
cd ..
Ask_y_n "Start Installation"
if [ $? -eq $YES_ANS ]
then
   echo ""
   echo "After installing the kernel, the system will reboot."
   echo "Login as root and run \"sh /usr/bin/install-win4lin.sh\""
   echo ""
   sh install-kernel.sh
fi
echo "See Release Notes for further instructions"

exit 0
